<template>
  <div class="container has-text-left pb-5">
    <h2 class="title">Policies</h2>
    <h3 class="subtitle">Contracts</h3>
    <p class="mb-3"><em>Active contracts that are negotiated by this connector/OpenAPI Data app, both incoming (where this connector acts as consumer) and outgoing (where this connector acts as provider) contracts are shown.</em></p>
    <PolicyTable :policies="contracts" @delete="deleteContract" />
    <h3 class="subtitle">Offers</h3>
    <p class="mb-3"><em>Active offers that this connector provides as provider to allow contracts to be negotiated that are in line with these offers.</em></p>
    <PolicyTable :policies="offers" @delete="deleteOffer" />
    <b-tabs position="is-centered">
      <b-tab-item label="Add offer">
        <p class="mb-3"><em>Add a new offer related to this OpenAPI Data App to the Core Container's Policy Enforcement Framework</em></p>
        <PolicyForm @refreshOffers="getOffers" />
      </b-tab-item>
      <b-tab-item label="Policy checker">
        <p class="mb-3"><em>Check which policy or contract is applicable to a certain request and get an estimation of the decision that will be taken</em></p>
        <PolicyChecker :contracts="contracts" :offers="offers" />
      </b-tab-item>
    </b-tabs>
  </div>
</template>

<style scoped>
.form-rule {
  position: relative;
  margin-left: 2rem;
  margin-bottom: 2rem;
  padding-bottom: 1rem;
  border-bottom: 1px solid lightgrey;
}
.form-rule > button {
    position: absolute;
    right: 1rem;
    bottom: 1rem;
}
</style>

<script lang="ts">
import { Component, Prop, Vue, Watch } from 'vue-property-decorator';
import axios from 'axios';
import moment from 'moment-timezone';
import PolicyTable from '../components/PolicyTable.vue'
import PolicyForm from '../components/PolicyForm.vue'
import PolicyChecker from '../components/PolicyChecker.vue'

@Component({
  filters: {
    formatDate: (date: Date): string => {
      return moment(date).tz(moment.tz.guess()).format('YYYY-MM-DD')
    }
  },
  components: {
    PolicyTable,
    PolicyForm,
    PolicyChecker
  }
})
export default class Policies extends Vue {
  offersInterval = -1

  contractsInterval = -1

  offers: Array<any> = []

  contracts: Array<any> = []

  private api = axios.create({
    baseURL: 'policies',
  });
  

  async created() {
    await Promise.all([
      this.getOffers(),
      this.getContracts()
    ]);
    this.offersInterval = setInterval(this.getOffers, 15000);
    this.contractsInterval = setInterval(this.getContracts, 15000);
  }

  beforeDestroy() {
    clearInterval(this.offersInterval);
    clearInterval(this.contractsInterval);
  }

  async getOffers() {
    const offers = await this.api.get('offers');
    offers.data.forEach((offer: any) => {
      offer.id = offer['@id'];
    });
    this.offers = offers.data;
  }

  async getContracts() {
    const contracts = await this.api.get('contracts');
    contracts.data.forEach((contract: any) => {
      contract.id = contract['@id'];
    });
    this.contracts = contracts.data;
  }

  async deleteContract(contractId: string) {
    this.$buefy.dialog.confirm({
        message: `Are you sure you want to delete contract <small><code>${contractId}</code></small>?`,
        onConfirm: async () => {
          console.log(`Delete contract: ${contractId}`);
          await this.api.delete('contracts', {
            params: {
              contractId,
            },
          });
          await this.getContracts();
        }
    });
  }

  async deleteOffer(offerId: string) {
    this.$buefy.dialog.confirm({
        message: `Are you sure you want to delete offer <small><code>${offerId}</code></small>?`,
        onConfirm: async () => {
          await this.api.delete('offers', {
            params: {
              offerId,
            },
          });
          await this.getOffers();
        }
    });
  }
}
</script>
